---

- name: "set webserver ip (hypervisor)"
  set_fact:
    preseed_server: "{{public_br.ip_addr|ipaddr('address')}}"
  when: "'controller' in hostvars[inventory_hostname].group_names"

- name: "set webserver ip (controller)"
  set_fact:
    preseed_server: "{{hostvars[inventory_hostname].groups.controller[0]}}"
  when: "'controller' not in hostvars[inventory_hostname].group_names"

- debug: "var=vars.ansible_delegated_vars"

# this should return the hypervisor's name

- name: "set webserver name when we should not be using private network"
  set_fact:
    preseed_server: '{{hostvars[inventory_hostname].groups.hypers.0}}'
  when: 'no_private_net is defined and no_private_net == "True"'

- debug: "var=preseed_server"

- block:

  # install the preseed server and contents
  - name: "install the web service on the machine"
    apt:
      name: 'nginx'
      state: 'latest'

  # copy the content to the web server
  - name: 'copy contents to the web server'
    copy: 
      src: 'nginx/'
      dest: '{{pxe_nginx.data_path}}'

  - name: "template preseed file"
    template:
      src: "jmmc-ubuntu-server.seed.j2"
      dest: "{{pxe_nginx.data_path}}/preseed/jmmc-ubuntu-server.seed"

  - name: "template postinstall file"
    template:
      src: "jmmc-ubuntu-server.postinstall.j2"
      dest: "{{pxe_nginx.data_path}}/preseed/jmmc-ubuntu-server.postinstall"

  - name: "copy ssh key from ansible user to the public directory"
    copy:
      src: "{{((vars.playbook_dir|dirname)|dirname)}}/.ssh/id_ed25519.pub"
      dest: "{{pxe_nginx.data_path}}/preseed/jmmc-id_ed25519.pub"
      remote_src: "True"

  # configure and enable the virtual host
  # should reload only if one of those 2 has changed
  - name: "configure a virtual host"
    template:
      src: 'nginx-preseed.j2'
      dest: '/etc/nginx/sites-available/default'


  - name: "add the virtual host"
    file:
      state: 'link'
      src: '/etc/nginx/sites-available/default'
      dest: '/etc/nginx/sites-enabled/default'


  - name: "reload the web service"
    service:
      name: 'nginx'
      state: 'reloaded'

  delegate_to: '{{preseed_server}}'

